'WODSORT.BAS
'Program to sort and merge files of tabulated WOD
'Written by C.Wallis G3CWV
'Created 17-July-94
'Version 1.0      01-Nov-95

'ON ERROR GOTO error.trap
'KEY 15, CHR$(1)
'KEY(15) ON
'ON KEY(15) GOSUB key.trap

KEY(1) ON
ON KEY(1) GOSUB key.trap

CLOSE

FALSE = 0
TRUE = -1

DEF FNyes
'Tests string reply for Y or y
IF ((reply$ = "Y") OR (reply$ = "y")) THEN
        FNyes = TRUE
        ELSE FNyes = FALSE
END IF
END DEF

PRINT : PRINT : PRINT
INPUT "Enter number of channels in data file  2 ... 10   ", channels
buffer.size = 16484 / channels
REDIM buffer%(buffer.size, channels)
PRINT
DO
    INPUT "Enter first input file name   ", in.file$
    PRINT
    OPEN in.file$ FOR INPUT ACCESS READ AS #1
LOOP UNTIL ERR = 0
DO
    INPUT "Enter output file name   ", out.file$
    PRINT
    OPEN out.file$ FOR OUTPUT ACCESS WRITE AS #2
LOOP UNTIL ERR = 0
PRINT "Please wait .... setting array"
FOR i% = 0 TO buffer.size
buffer%(i%, 0) = -1
NEXT
PRINT "          ...... processing file"
PRINT
DO
 DO WHILE NOT EOF(1)
    FOR i = 0 TO channels
        IF NOT EOF(1) THEN INPUT #1, n% ELSE EXIT FOR
        IF i = 0 THEN ptr = n%
        buffer%(ptr, i) = n%
    NEXT
 LOOP
 GOSUB report.holes
 PRINT
 INPUT "Do you wish to merge ANOTHER input file?  <Y/N>  ", reply$
 IF FNyes THEN
        CLOSE 1
        DO
            INPUT "Enter next input file name   ", in.file$
            OPEN in.file$ FOR INPUT ACCESS READ AS #1
        LOOP UNTIL ERR = 0
 END IF
LOOP WHILE FNyes

FOR i = 0 TO buffer.size
      IF buffer%(i, 0) <> -1 THEN
        FOR j = O TO channels
              PRINT #2, buffer%(i, j);
        NEXT
        PRINT #2,
      END IF
NEXT
CLOSE
SYSTEM
END

'---------------------------------------------

report.holes:

i = 0
lines.missing = 0
number.of.holes = 0
hole = FALSE
WHILE i < buffer.size
IF hole THEN                                  'already in hole
                IF buffer%(i, 0) <> -1 THEN
                             hole.end = i - 1
                             hole = FALSE
REM                              PRINT hole.start, hole.end
                             lines.missing = lines.missing + hole.end - hole.start + 1
                 END IF
        ELSE                                  'start of hole
               IF buffer%(i, 0) = -1 THEN
                             hole.start = i
                             hole = TRUE
                             number.of.holes = number.of.holes + 1
               END IF
END IF
i = i + 1
WEND
PRINT
PRINT "Total number of holes           "; number.of.holes
PRINT "Total number of lines missing   "; lines.missing
RETURN
'----------------------------------------------

key.trap:
        END
RETURN
'----------------------------------------------

error.trap:
 return.flag = FALSE
 SELECT CASE ERR
    CASE 53
        PRINT "File not found"
        return.flag = TRUE
    CASE 52, 64, 76, 68
        PRINT "Bad file or path name"
        return.flag = TRUE
    CASE 71
        PRINT "Disk not ready"
        return.flag = TRUE
    CASE 72
        PRINT "Disk error"
 END SELECT

 IF return.flag THEN
                    RESUME NEXT
                ELSE
                    PRINT "Error number  "; ERR
                    SYSTEM
 END IF
 REM ------------

